#include 	<stdio.h>
#include	<string.h>
#include 	"compilerApi.h"
#include        "ext_func.h"
#define		IDSTR	"A"
void tranform_func2(SgStatement *);
//tansform the where construct to where statement in a given function

int     whereconstruct_to_where(SgStatement *);
//change the where construct to where statement 

int 	scalarize_exp(SgStatement *,SgExpression *,SgExpression **,int, SgSubscriptExp **);
//scalarize the given exp to scalar form,some time we need the subscript 
//of the exp ,int variable denote the start index variable number.

SgVariableSymb	*get_temp_variable(SgStatement *,SgType *,char*);
//return a temporary variable and declare it in given statement

SgVariableSymb	*get_temp_index(int,SgStatement *,char *);
//return an index variable and declare it in given statement
//int variable is the digit used in the index variable. 

void	init_temp_index(SgStatement *);
//initialize index variable

int	isBinaryOp(SgExpression *);
//judge if given expression have left hand and right hand

SgExpression *scalarize_AryRef_exp(SgStatement *,SgExpression *,int,SgExpression **,int,SgSubscriptExp**,int *);
//scalarize the given array reference variable and return forall header if 
//set forall flag sometime we need subscript and the another int variable 
//is used for index variable digit

int is_function(SgExpression *);
//if the expression is any form of function call or function reference or user defined operator 

SgExpression * get_constructor_num(SgExpression * );//array constructor have how many elements
SgExpression * ac_implied_do(SgExpression * );//the implied do variable repeats how many times repeat
SgExpression * ac_value_list(SgExpression * );//the ac_value_list has how many elements 
SgType * array_exp_type(SgExpression * ); // get the exp's type .
int get_subscript(SgExpression *,SgSubscriptExp**);
//if the expression is array expression ,get its low bound ,up bound and 
//step , return its dimension,elst return 0 represent scalar expression.
//here we only consider one dimension.
 
//extern SgVariableSymb	*temp_index[8];
extern SgValueExp	*base_lbound;//default forall index variable start from 0
extern SgValueExp 	*base_step;//default step is 1
extern SgValueExp	*default_lsub;//Fortran default low bound is 1
//extern SgStatement     *current;//current statement to be transformed

//extern int		index_g;//digit for forall index variable. 
//extern int		index_var;//digit for temporary variable.


SgType * array_exp_type(SgExpression * exp)
{
	SgVariableSymb	*array_name;//the rightest variable name or array
					// subobject name.
	SgSubscriptExp	*subscript;//the subscript expression of i dimension
	SgArrayType	*array_type;//the type of array name
	SgType		*return_type;
	SgExpression	*expr_list;//subscript expression list
	SgExpression    *lbound , *ubound, *step;// the low bound,up bound,
						// and step of i dimension
	int 		i_dim;//the i dimension of array name
	int		total_dim;//how many dimension of array name
	int		scalar_or_array;
	SgExpression 	*cur_exp=exp;//the expression to be scalarized
	SgExpression	*rec_exp;//record reference expression	
	SgExpression	*temp1,*temp;
    	SgType          *type;
	SgVariableSymb	*temp_sym;
	SgExpression	*exp1,*exp2,*exp3,*exp4;
	SgExprListExp	*exp5;
	SgVarRefExp	*var_exp;
	SgExpression	*ary_sub,*ary_sub_res;//used when array subscript is int expression
	SgExpression	*range;
	// reduce RECORD_REF to ARRAY_REF,get the rightest expression if record
	if (isSgRecordRefExp(cur_exp)) {
		while (cur_exp->rhs()) {
			cur_exp=cur_exp->rhs()->lhs();

		}
		rec_exp=cur_exp;              // save this pointer !!
		//cur_exp=cur_exp->lhs();
		// now RECORD_REF is reduced to VAR_REF or ARRAY_REF in cur_exp.
	}
	expr_list=cur_exp->lhs();                   // subscipt list
	array_name=(SgVariableSymb *) (cur_exp->symbol());
	array_type=(SgArrayType *) (array_name->type());
//	((SgArrayType*)return_type)->setBaseType(*(array_type->baseType()));
	return_type=new SgArrayType(*(array_type->baseType()));
	//return_type=cur_exp->type();
	total_dim=array_type->dimension();               // dimension

	for (i_dim=0;i_dim<total_dim;i_dim++) {
	  subscript=(SgSubscriptExp *)array_type->sizeInDim(i_dim);
	  if (isSgVarRefExp(cur_exp)) {
	  	// form like A,A%B,...
		ubound=(subscript->ubound());
		lbound=(subscript->lbound());
		step=(subscript->step());
 	        range=&(((*ubound)-(*lbound))/(*step)+(*base_step));
		range=new SgExpression(RANGE_OP,NULL,range,NULL);
                range=new SgExpression(DDOT,range,NULL,NULL);
                ((SgArrayType *)return_type)->addRange(*range);

	  }//end of VarRefExp
	  else 
	  if (expr_list->lhs()->variant()==DDOT){
		// form like A(1:10:2),A(1:10),A(1:),A(:10:2),A(1::2),A(::2),...

		temp=expr_list->lhs();//DDOT expression
		temp1=temp->rhs();//step expr
		if (temp1) {step=temp1;}//initial value
		    else {step=base_step;}//default
		temp=temp->lhs();//RANGE expression
		temp1=temp->lhs();//low bound expression
		if (temp1) {lbound=temp1;}//initial value
		    else {lbound=(subscript->lbound());}//defined array variable's lbound
		  temp1=temp->rhs();//up bound expression
		   if (temp1)  { ubound=temp1; }//initial value
		     else 	{ubound=(subscript->ubound());}//defined array variable's ubound
		expr_list=expr_list->rhs();// expr_list now point to the next dimension
 	
                range=&(((*ubound)-(*lbound))/(*step)+(*base_step));
		range=new SgExpression(RANGE_OP,NULL,range,NULL);
                range=new SgExpression(DDOT,range,NULL,NULL);
                ((SgArrayType *)return_type)->addRange(*range);

	  }//end of DDOT
	  else
	  {
		  // array or scalar expression:
		  // Vector subscript like A((/1,2,3/)),scalar subscript like A(i,:)
		  // array expression like A(B+C),B and C are one dimension array,vector subscript is
		  //one dimension int array expression.
		  ary_sub=expr_list->lhs();
		  expr_list=expr_list->rhs();//point to the next dimension subscript
		  scalar_or_array=get_subscript(ary_sub,&subscript);
		  if (scalar_or_array==0){
			
		  	continue;
		  }else
		  {
			//ary_sub is array expression
			//specification restrict the ary_sub must be rank=1 integer array expression
			//only here we use the subscript calculated by  scalarize_exp(....)
			ubound=(subscript->ubound());
		  	lbound=(subscript->lbound());
		      	step=(subscript->step());
 	                range=&(((*ubound)-(*lbound))/(*step)+(*base_step));
			range=new SgExpression(RANGE_OP,NULL,range,NULL);
                	range=new SgExpression(DDOT,range,NULL,NULL);
        	        ((SgArrayType *)return_type)->addRange(*range);
		  }
	  }//end of int_expr subscript

    	}  // end of for loop
	return return_type;
}

int get_subscript(SgExpression * exp,SgSubscriptExp** subscript)
{

	SgExpression	*left_tree,*right_tree;
	SgExpression	*cur_exp=exp;
	int		l_dim=0,r_dim=0;
	SgArrayType	*array_type;
	SgExpression	*range;
	
	if (isBinaryOp(cur_exp))
	{	
		left_tree=cur_exp->lhs();
		right_tree=cur_exp->rhs();	
		if (left_tree)
		l_dim=get_subscript(left_tree,subscript);
		if (l_dim!=0) return(l_dim);
		if (right_tree)
		r_dim=get_subscript(right_tree,subscript);
		return (r_dim);
	}// end of binary operator
	else 
	if (isSgUnaryExp(cur_exp))
	{
		left_tree=cur_exp->lhs();
		if (left_tree)
		l_dim=get_subscript(left_tree,subscript);
	}// end of unary operator
	else
	if (cur_exp->thellnd->variant==ARRAY_CONSTRUCTOR)
	{ 

		range=get_constructor_num(cur_exp);
		*subscript=new SgSubscriptExp(*default_lsub,*range,*base_step);
		l_dim=1;
	}//end of ARRAY CONSTRUCTOR
	else 
	if (isSgArrayType(cur_exp->type()))
	//array reference
        {
		array_type=(SgArrayType*)array_exp_type(cur_exp);
		*subscript=(SgSubscriptExp *)(array_type->sizeInDim(0));
		l_dim=1;
        }
	else
	//scalar
	{
		l_dim=0;
	}
	return(l_dim);
}

